program checkoutput

use sasdal
use dal
use errorhandling
use realsame_mod

implicit none

type(DataSetT) :: regDataSet, listDataSet
type(TableT) :: tableSet, listTableSet
type(ColumnT) :: shapeCol
type(ColumnT) :: xCol, xposCol
type(ColumnT) :: yCol, yPosCol, rCol

character(len=255) :: window0                                   ! Origin of the OSW
integer(kind=int32) :: windowX0, windowX1, windowY0, windowY1   ! Coordinates of the OSW origin
character(len=1) :: ch1, ch2, ch3, ch4, ch5
!---

real(kind=single), pointer :: rArray(:,:)
character(len=20) shape
real(kind=Single), pointer :: xpos(:), ypos(:), xval(:,:), yval(:,:)
integer :: nrows

regDataSet = dataSet("source.fts",read)
listDataSet = dataSet("testlist.fts",read)
tableSet = table(regDataSet, "REGION")
listTableSet = table(listDataSet, "SRCLIST")


window0 = stringAttribute(listDataSet, "DETSEC")

read (window0, '(A1, I4, A1, I4, A1, I4, A1, I4, A1)') ch1,windowX0, ch2, windowX1, ch3,  windowY0, ch4, windowY1, ch5

nrows = numberOfRows(tableSet)
if (nRows /= 1) call fatal("nRows","Wrong number of rows in source file")
shapeCol = column(tableSet,"SHAPE", read)
shape = stringCell(shapeCol,0)

xCol = column(tableSet,"X", read)
xval => real32VectorData(xCol)

yCol = column(tableSet,"Y", read)
yval => real32VectorData(yCol)

xposCol = column(listTableSet,"XPOS",read)
xpos => real32data(xposCol)


yposCol = column(listTableSet,"YPOS",read)
ypos => real32data(yposCol)


if (.not.realsame(xval(0,0),xpos(0)+windowX0,1.e-3)) call fatal("xpos","Wrong x position")

if (.not.realsame(yval(0,0),ypos(0)+windowY0,1.e-3)) call fatal("ypos","Wrong y position")


call release(xposCol)
call release(yposCol)
call release(listTableSet)
call release(listDataSet)
call release(xCol)
call release(yCol)
call release(shapeCol)
call release(tableSet)
call release(regDataSet)



regDataSet = dataSet("back.fts",read)
tableSet = table(regDataSet, "REGION")
nrows = numberOfRows(tableSet)
if (nRows /= 1) call fatal("nRows","Wrong number of rows in source file")
shapeCol = column(tableSet,"SHAPE", read)
shape = stringCell(shapeCol,0)

rCol = column(tableSet, "R", read)

rArray => real32VectorData(rCol)

if (rArray(0,0) > rArray(1,0)) then
   call fatal("badAnnulus", "rInner greater than rOuter")
endif

call release(shapeCol)
call release(tableSet)
call release(regDataSet)


end
